Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 159001 - Executing file on NFS client gets corrupted if updated on server
Summary: Executing file on NFS client gets corrupted if updated on server
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel
Version: 3.0
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Steve Dickson
QA Contact: Brian Brock
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2005-05-27 15:35 UTC by Göran Uddeborg
Modified: 2007-11-30 22:07 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2007-10-19 19:01:23 UTC


Attachments (Terms of Use)

Description Göran Uddeborg 2005-05-27 15:35:40 UTC
Description of problem:
If an NFS client is executing a file which is loaded over NFS, and this file is
modified on some other client or on the server, the file becomes corrupt on the
client executing.  Its attributes are correct, but the contents is wrong.  It is
neither the old nor the new contents.  The error remains even after the process
on the client has died.

Version-Release number of selected component (if applicable):
kernel-2.4.21-32.EL
(The file server is running RHEL 4, kernel-2.6.9-5.0.5.EL and nfs-utils-1.0.6-46)

How reproducible:
Every time

Steps to Reproduce:
1.On the file server:
livingston> sudo cp /bin/sleep mysleep
livingston> sudo cp /bin/sleep mysleep2
livingston> sha1sum mysleep*
e208767d5b7e2ea6722eceaa1eb52d010dd7edf8  mysleep
e208767d5b7e2ea6722eceaa1eb52d010dd7edf8  mysleep2
2.On the client:
schellville> sha1sum mysleep*
e208767d5b7e2ea6722eceaa1eb52d010dd7edf8  mysleep
e208767d5b7e2ea6722eceaa1eb52d010dd7edf8  mysleep2
# So far so good
3.Run one of the files on the client:
schellville> ./mysleep 1000&
[1] 4481
4.Overwrite the files on the server:
livingston> sudo cp /bin/true mysleep
livingston> sudo cp /bin/true mysleep2
livingston> sha1sum mysleep*
932416b277df96a7a9b96f9cb44f1d6d3ed57bb8  mysleep
932416b277df96a7a9b96f9cb44f1d6d3ed57bb8  mysleep2
5.Now, the files look different on the client:
schellville> sha1sum mysleep*
5a5ded209c0e327b87680e49552b633a213ca86b  mysleep
932416b277df96a7a9b96f9cb44f1d6d3ed57bb8  mysleep2

Actual results:
mysleep and mysleep2 differ; mysleep is corrupt.

Expected results:
They should both be updated.

Additional info:
Note that it's neither the new nor the old value in "mysleep" on the client.
Terminating the mysleep process on the client doesn't change anything.  Even
long after the process died, the contents of mysleep is still wrong.

We have seen this with both x86_64 and i386 clients.  The server in both cases
is a x86_64 machine.

Comment 2 RHEL Product and Program Management 2007-10-19 19:01:23 UTC
This bug is filed against RHEL 3, which is in maintenance phase.
During the maintenance phase, only security errata and select mission
critical bug fixes will be released for enterprise products. Since
this bug does not meet that criteria, it is now being closed.
 
For more information of the RHEL errata support policy, please visit:
http://www.redhat.com/security/updates/errata/
 
If you feel this bug is indeed mission critical, please contact your
support representative. You may be asked to provide detailed
information on how this bug is affecting you.


Note You need to log in before you can comment on or make changes to this bug.